# MyDBF2MySQL - Software for transferring DBF into MySQL.
# Copyright (C) 2008-2010 Polyakov Andrey
#
# http://sourceforge.net/projects/mydbf2mysql/
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation, version 2
# of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

from threading import Lock


class progressCounterST(object):
    _iInstance = None

    class progressCounter(object):
        __processed = 0
        __failed = 0
        __failedLock = Lock()
        __processedLock = Lock()

        def increaseProcessed(self, value):
            self.__processedLock.acquire()
            self.__processed += value
            self.__processedLock.release()

        def increaseFailed(self, value):
            self.__failedLock.acquire()
            self.__failed += value
            self.__failedLock.release()

        def increaseValues(self, processed, failed):
            if processed > 0:
                self.increaseProcessed(processed)
            if failed > 0:
                self.increaseFailed(failed)

        def getFailed(self):
            return self.__failed

        def getProcessed(self):
            return self.__processed

    def __init__(self):
        if progressCounterST._iInstance is None:
            progressCounterST._iInstance = progressCounterST.progressCounter()
        self.__dict__['_EventHandler_instance'] = progressCounterST._iInstance

    def __getattr__(self, aAttr):
        return getattr(self._iInstance, aAttr)

    def __setattr__(self, aAttr, aValue):
        return setattr(self._iInstance, aAttr, aValue)

